// Code generated by go-swagger; DO NOT EDIT.

package logs

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetWorkflowLogsParams creates a new GetWorkflowLogsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetWorkflowLogsParams() *GetWorkflowLogsParams {
	return &GetWorkflowLogsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetWorkflowLogsParamsWithTimeout creates a new GetWorkflowLogsParams object
// with the ability to set a timeout on a request.
func NewGetWorkflowLogsParamsWithTimeout(timeout time.Duration) *GetWorkflowLogsParams {
	return &GetWorkflowLogsParams{
		timeout: timeout,
	}
}

// NewGetWorkflowLogsParamsWithContext creates a new GetWorkflowLogsParams object
// with the ability to set a context for a request.
func NewGetWorkflowLogsParamsWithContext(ctx context.Context) *GetWorkflowLogsParams {
	return &GetWorkflowLogsParams{
		Context: ctx,
	}
}

// NewGetWorkflowLogsParamsWithHTTPClient creates a new GetWorkflowLogsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetWorkflowLogsParamsWithHTTPClient(client *http.Client) *GetWorkflowLogsParams {
	return &GetWorkflowLogsParams{
		HTTPClient: client,
	}
}

/* GetWorkflowLogsParams contains all the parameters to send to the API endpoint
   for the get workflow logs operation.

   Typically these are written to a http.Request.
*/
type GetWorkflowLogsParams struct {

	/* FilterField.

	   field to filter
	*/
	PageFilterField *string

	/* FilterType.

	   filter behaviour
	*/
	PageFilterType *string

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* OrderDirection.

	   order direction
	*/
	PageOrderDirection *string

	/* OrderField.

	   field to order by
	*/
	PageOrderField *string

	/* Workflow.

	   path to target workflow
	*/
	Workflow string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get workflow logs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetWorkflowLogsParams) WithDefaults() *GetWorkflowLogsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get workflow logs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetWorkflowLogsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get workflow logs params
func (o *GetWorkflowLogsParams) WithTimeout(timeout time.Duration) *GetWorkflowLogsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get workflow logs params
func (o *GetWorkflowLogsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get workflow logs params
func (o *GetWorkflowLogsParams) WithContext(ctx context.Context) *GetWorkflowLogsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get workflow logs params
func (o *GetWorkflowLogsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get workflow logs params
func (o *GetWorkflowLogsParams) WithHTTPClient(client *http.Client) *GetWorkflowLogsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get workflow logs params
func (o *GetWorkflowLogsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithPageFilterField adds the filterField to the get workflow logs params
func (o *GetWorkflowLogsParams) WithPageFilterField(filterField *string) *GetWorkflowLogsParams {
	o.SetPageFilterField(filterField)
	return o
}

// SetPageFilterField adds the filterField to the get workflow logs params
func (o *GetWorkflowLogsParams) SetPageFilterField(filterField *string) {
	o.PageFilterField = filterField
}

// WithPageFilterType adds the filterType to the get workflow logs params
func (o *GetWorkflowLogsParams) WithPageFilterType(filterType *string) *GetWorkflowLogsParams {
	o.SetPageFilterType(filterType)
	return o
}

// SetPageFilterType adds the filterType to the get workflow logs params
func (o *GetWorkflowLogsParams) SetPageFilterType(filterType *string) {
	o.PageFilterType = filterType
}

// WithNamespace adds the namespace to the get workflow logs params
func (o *GetWorkflowLogsParams) WithNamespace(namespace string) *GetWorkflowLogsParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the get workflow logs params
func (o *GetWorkflowLogsParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithPageOrderDirection adds the orderDirection to the get workflow logs params
func (o *GetWorkflowLogsParams) WithPageOrderDirection(orderDirection *string) *GetWorkflowLogsParams {
	o.SetPageOrderDirection(orderDirection)
	return o
}

// SetPageOrderDirection adds the orderDirection to the get workflow logs params
func (o *GetWorkflowLogsParams) SetPageOrderDirection(orderDirection *string) {
	o.PageOrderDirection = orderDirection
}

// WithPageOrderField adds the orderField to the get workflow logs params
func (o *GetWorkflowLogsParams) WithPageOrderField(orderField *string) *GetWorkflowLogsParams {
	o.SetPageOrderField(orderField)
	return o
}

// SetPageOrderField adds the orderField to the get workflow logs params
func (o *GetWorkflowLogsParams) SetPageOrderField(orderField *string) {
	o.PageOrderField = orderField
}

// WithWorkflow adds the workflow to the get workflow logs params
func (o *GetWorkflowLogsParams) WithWorkflow(workflow string) *GetWorkflowLogsParams {
	o.SetWorkflow(workflow)
	return o
}

// SetWorkflow adds the workflow to the get workflow logs params
func (o *GetWorkflowLogsParams) SetWorkflow(workflow string) {
	o.Workflow = workflow
}

// WriteToRequest writes these params to a swagger request
func (o *GetWorkflowLogsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.PageFilterField != nil {

		// query param filter.field
		var qrFilterField string

		if o.PageFilterField != nil {
			qrFilterField = *o.PageFilterField
		}
		qFilterField := qrFilterField
		if qFilterField != "" {

			if err := r.SetQueryParam("filter.field", qFilterField); err != nil {
				return err
			}
		}
	}

	if o.PageFilterType != nil {

		// query param filter.type
		var qrFilterType string

		if o.PageFilterType != nil {
			qrFilterType = *o.PageFilterType
		}
		qFilterType := qrFilterType
		if qFilterType != "" {

			if err := r.SetQueryParam("filter.type", qFilterType); err != nil {
				return err
			}
		}
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if o.PageOrderDirection != nil {

		// query param order.direction
		var qrOrderDirection string

		if o.PageOrderDirection != nil {
			qrOrderDirection = *o.PageOrderDirection
		}
		qOrderDirection := qrOrderDirection
		if qOrderDirection != "" {

			if err := r.SetQueryParam("order.direction", qOrderDirection); err != nil {
				return err
			}
		}
	}

	if o.PageOrderField != nil {

		// query param order.field
		var qrOrderField string

		if o.PageOrderField != nil {
			qrOrderField = *o.PageOrderField
		}
		qOrderField := qrOrderField
		if qOrderField != "" {

			if err := r.SetQueryParam("order.field", qOrderField); err != nil {
				return err
			}
		}
	}

	// path param workflow
	if err := r.SetPathParam("workflow", o.Workflow); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
