// Code generated by go-swagger; DO NOT EDIT.

package node

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetNodesParams creates a new GetNodesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetNodesParams() *GetNodesParams {
	return &GetNodesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetNodesParamsWithTimeout creates a new GetNodesParams object
// with the ability to set a timeout on a request.
func NewGetNodesParamsWithTimeout(timeout time.Duration) *GetNodesParams {
	return &GetNodesParams{
		timeout: timeout,
	}
}

// NewGetNodesParamsWithContext creates a new GetNodesParams object
// with the ability to set a context for a request.
func NewGetNodesParamsWithContext(ctx context.Context) *GetNodesParams {
	return &GetNodesParams{
		Context: ctx,
	}
}

// NewGetNodesParamsWithHTTPClient creates a new GetNodesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetNodesParamsWithHTTPClient(client *http.Client) *GetNodesParams {
	return &GetNodesParams{
		HTTPClient: client,
	}
}

/* GetNodesParams contains all the parameters to send to the API endpoint
   for the get nodes operation.

   Typically these are written to a http.Request.
*/
type GetNodesParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* NodePath.

	   target path in tree
	*/
	NodePath string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get nodes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetNodesParams) WithDefaults() *GetNodesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get nodes params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetNodesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get nodes params
func (o *GetNodesParams) WithTimeout(timeout time.Duration) *GetNodesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get nodes params
func (o *GetNodesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get nodes params
func (o *GetNodesParams) WithContext(ctx context.Context) *GetNodesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get nodes params
func (o *GetNodesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get nodes params
func (o *GetNodesParams) WithHTTPClient(client *http.Client) *GetNodesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get nodes params
func (o *GetNodesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the get nodes params
func (o *GetNodesParams) WithNamespace(namespace string) *GetNodesParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the get nodes params
func (o *GetNodesParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithNodePath adds the nodePath to the get nodes params
func (o *GetNodesParams) WithNodePath(nodePath string) *GetNodesParams {
	o.SetNodePath(nodePath)
	return o
}

// SetNodePath adds the nodePath to the get nodes params
func (o *GetNodesParams) SetNodePath(nodePath string) {
	o.NodePath = nodePath
}

// WriteToRequest writes these params to a swagger request
func (o *GetNodesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param nodePath
	if err := r.SetPathParam("nodePath", o.NodePath); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
