// Code generated by go-swagger; DO NOT EDIT.

package registries

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateGlobalRegistryParams creates a new CreateGlobalRegistryParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateGlobalRegistryParams() *CreateGlobalRegistryParams {
	return &CreateGlobalRegistryParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateGlobalRegistryParamsWithTimeout creates a new CreateGlobalRegistryParams object
// with the ability to set a timeout on a request.
func NewCreateGlobalRegistryParamsWithTimeout(timeout time.Duration) *CreateGlobalRegistryParams {
	return &CreateGlobalRegistryParams{
		timeout: timeout,
	}
}

// NewCreateGlobalRegistryParamsWithContext creates a new CreateGlobalRegistryParams object
// with the ability to set a context for a request.
func NewCreateGlobalRegistryParamsWithContext(ctx context.Context) *CreateGlobalRegistryParams {
	return &CreateGlobalRegistryParams{
		Context: ctx,
	}
}

// NewCreateGlobalRegistryParamsWithHTTPClient creates a new CreateGlobalRegistryParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateGlobalRegistryParamsWithHTTPClient(client *http.Client) *CreateGlobalRegistryParams {
	return &CreateGlobalRegistryParams{
		HTTPClient: client,
	}
}

/* CreateGlobalRegistryParams contains all the parameters to send to the API endpoint
   for the create global registry operation.

   Typically these are written to a http.Request.
*/
type CreateGlobalRegistryParams struct {

	/* RegistryPayload.

	   Payload that contains registry data
	*/
	RegistryPayload CreateGlobalRegistryBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create global registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGlobalRegistryParams) WithDefaults() *CreateGlobalRegistryParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create global registry params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateGlobalRegistryParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create global registry params
func (o *CreateGlobalRegistryParams) WithTimeout(timeout time.Duration) *CreateGlobalRegistryParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create global registry params
func (o *CreateGlobalRegistryParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create global registry params
func (o *CreateGlobalRegistryParams) WithContext(ctx context.Context) *CreateGlobalRegistryParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create global registry params
func (o *CreateGlobalRegistryParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create global registry params
func (o *CreateGlobalRegistryParams) WithHTTPClient(client *http.Client) *CreateGlobalRegistryParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create global registry params
func (o *CreateGlobalRegistryParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithRegistryPayload adds the registryPayload to the create global registry params
func (o *CreateGlobalRegistryParams) WithRegistryPayload(registryPayload CreateGlobalRegistryBody) *CreateGlobalRegistryParams {
	o.SetRegistryPayload(registryPayload)
	return o
}

// SetRegistryPayload adds the registryPayload to the create global registry params
func (o *CreateGlobalRegistryParams) SetRegistryPayload(registryPayload CreateGlobalRegistryBody) {
	o.RegistryPayload = registryPayload
}

// WriteToRequest writes these params to a swagger request
func (o *CreateGlobalRegistryParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.RegistryPayload); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
